package scacchi.soluzione;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.imageio.*;
import java.io.*;
import scacchi.main.Partita;
import scacchi.main.ArgomentiComando.*;
import scacchi.main.EccezioniTesto.*;
import scacchi.main.EccezioniPartita.*;
/**classe per implementare l'interfaccia grafica per il gioco degli scacchi
	
*/
public class GiocaAScacchi extends Frame implements ActionListener{
	
	/**
		Immagine che conterr la scacchiera
	*/
	BufferedImage scacchiera;
	/**
	Immagine per il doppio buffer (per evitare lo sfarfallio)
	*/
	Image buffer;
	
	/** serve per tenere conto dello sfasamento tra il buffer fuori dallo schermo e le immagini disegnate sullo schermo
	*/
	int offset=30;
	/**
		Salva la posizione iniziale del pezzo che si st muovendo
	*/
	String partenza="";
	/**
		Salva la posizione iniziale del pezzo che si st muovendo
	*/
	String arrivo="";
	/**
		Contiene il nome del pezzo in cui il pedone verr promosso
		@see #setPromozione
	*/
	String promozione="";
	/** tiene conto della differenza tra la x del mouse e la x dell'angolo in alto a sinistra del pezzo selezionato
	*/
	int dx;
	/** tiene conto della differenza tra la y del mouse e la y dell'angolo in alto a sinistra del pezzo selezionato
	*/
	int dy;
	/** lista delle caselle della scacchiera
		@see GiocaAScacchi.Caselle
	*/
	Caselle lista[][];
	/** casalla (se esiste) sulla quale viene lasciato il pezzo 
		@see GiocaAScacchi.Caselle
	*/
	Caselle casellaArrivo;
	/** pezzo selezionato con il mouse
		@see GiocaAScacchi.Pezzo
	*/
	Pezzo pick;
	/**
		Nome del pezzo preso
		@see #pick
	*/
	String pickName="";
	/**
		la partita vera e propria, tutto il resto fa da interfaccia grafica per PartitaScacchi
	*/
	PartitaScacchi partita;
	/**
		Posizione dei pezzi
	
	*/
	ListaPosPezziTesto LPPT;
	/**
		Posizione dei pezzi (come stringa)
	*/
	String listaPezzi;
	/**
		serve per iniziare una nuova partita da una posizione non standard: indica chi deve muovere
	*/
	int tratto;
	/**
		Posizione dei pezzi (come vettore di stringhe)
	*/
	String posPezzi[];
	/**
		Numero di stringhe in posPezzi
		@see #posPezzi
	*/
	int numPezzi;
	/**
		Pulsante per iniziare una nuova partita
	*/
	Button newgame;
	/**
		Pulsante per tornare indietro di una mossa
	*/
	Button indietro;
	/**
		Area di testo dove viene visualizzata la lista delle mosse eseguite
	*/
	TextArea mosse;
	/**
		Area di testo dove vengono visualizzate informazioni riguardo lo svolgimento della partita
	*/
	TextArea info;
	/**
		Crea l'interfaccia grafica, creando anche una nuova parita con i pezzi in posizione standard
	
	*/
	public GiocaAScacchi(){
		setSize(600,550);
		setTitle("Scacchi");
		setLayout(null);
		partita=new PartitaScacchi();
		
		try{
			scacchiera= ImageIO.read(new File("images/scacchiera.jpg"));
			buffer=ImageIO.read(new File("images/scacchiera.jpg"));
		}catch(IOException e){
			System.out.println(e);
		}
		
		aggiornaScacchiera(partita.getPosizionePezzi());
		newgame=new Button("nuova partita");
		newgame.setBounds(460,40,100,30);
		indietro=new Button("indietro");
		indietro.setBounds(460,80,80,30);
		mosse=new TextArea("",10,15,1);
		mosse.setBounds(460,120,130,290);
		mosse.setText("");
		mosse.setEditable(false);
		info=new TextArea("Nuova Partita",4,50,1);
		info.setBounds(30,450,560,80);
		info.setEditable(false);
		add(newgame);
		add(indietro);
		add(mosse);
		add(info);
		newgame.addActionListener(this);
		indietro.addActionListener(this);
		setVisible(true);
		addWindowListener(new MyWindowAdapter());
		addMouseListener(new MyMouseAdapter(this));
		addMouseMotionListener(new MyMouseMotionAdapter(this));
	}
	/**
		Lancia il costruttore dell'interfaccia
	*/
	public static void main( String args[]){
		GiocaAScacchi game=new GiocaAScacchi();
		
	
	}
	/**
		metodo sovrascritto, serve per eseguire i comandi appropriati a seconda di quale pulsante sia stato premuto
		@see #newgame
		@see #indietro
	*/
	public void actionPerformed(ActionEvent ae){
		String str=ae.getActionCommand();
		ListaPosPezziTesto vuota=null;
		if(str.equals("nuova partita")){
			setListaPezzi("");
			NewGameDialog d= new NewGameDialog(this,this,"Nuova Partita");
			d.setVisible(true);
			if(listaPezzi.equals(""))
			{
				partita=new PartitaScacchi();
				aggiornaScacchiera(partita.getPosizionePezzi());
				mosse.setText("");
				info.setText("Nuova Partita");
			}else{
				try{
					vuota=new ListaPosPezziTesto("");
					ListaPosPezziTesto l=new ListaPosPezziTesto(listaPezzi);
					try{
						partita=new PartitaScacchi(tratto,l);
						aggiornaScacchiera(partita.getPosizionePezzi());
						mosse.setText("");
						info.setText("Nuova Partita");
					}catch(PosizioneInizialeException pe){
						partita=null;
						aggiornaScacchiera(vuota);
						mosse.setText("");
						info.setText(pe.toString().substring(pe.toString().indexOf(":")+2));
					}
					
				}catch(NotazioneException ne){
					partita=null;
					aggiornaScacchiera(vuota);
					mosse.setText("");
					info.setText("Errore nella lista della posizione dei pezzi");
				}
				
			}
			paint(getGraphics());//al posto di repaint() cos si riduce lo sfarfallio
		}
		if(str.equals("indietro")){
			try{
				if(partita!=null)
				{
					aggiornaScacchiera(partita.tornaIndietro());
					mosse.setText(partita.listaMosse().toString());
					info.setText("Tornato indietro di una mossa");
					paint(getGraphics());//al posto di repaint() cos si riduce lo sfarfallio
				}
			}catch(NoMoreMosseException e){
				info.setText(e.toString().substring(e.toString().indexOf(":")+2));
				
			}	
		
		
		}
	}
	/**
		salva la posizione dei pezzi nella stringa listaPezzi
		@see #listaPezzi
	*/
	public void setListaPezzi(String lista)
	{
		listaPezzi=lista;
		
	}
	/**
		Imposta il nome del pezzo in cui promuovere i pedoni
		@see #promozione
	*/
	public void setPromozione(String pezzo)
	{
		if(pickName.equals(pickName.toLowerCase()))
		// il pezzo  nero
			pezzo=pezzo.toLowerCase();
		promozione="="+pezzo;
	}
	/**
		imposta la variabile tratto
		@see #tratto
	*/
	public void setTratto(int i)
	{
		tratto=i;
	}
	/**
		Aggiorna il disegno della scacchiera dopo aver effettuato la mossa
	*/
	public void aggiornaScacchiera(ListaPosPezziTesto l)
	{	
		String lettere[]={ "a", "b","c","d","e","f","g","h"};
		String numeri[]={ "8", "7","6","5","4","3","2","1"};
		LPPT=l;
		posPezzi=LPPT.v();
		numPezzi=LPPT.length();
		lista=new Caselle [8][8];
		for(int i=0;i<8;i++)
		{
			for(int j=0;j<8;j++)
			{
				lista[j][i]=new Caselle(50,50,j*50,i*50,lettere[j]+numeri[i]);
				if(casellaOccupata(lista[j][i]))
				{
					lista[j][i].addPezzo(getPezzo(lettere[j]+numeri[i]));
					
				}
			}
		}
	}
	/**
		Disegna i pezzi sulla scacchiera
		@see GiocaAScacchi.Pezzo
	*/
	public void disegnaPezzi(Graphics g){
		Pezzo temp;
		for(int i=0;i<8;i++)
		{
			for(int j=0;j<8;j++)
			{
				if(casellaOccupata(lista[j][i]))
				{
					temp=lista[j][i].getPezzo();
					if(temp!=pick)
						//il pezzo preso verr disegnato per ultimo
						g.drawImage(temp.getImage(), temp.getX()+5 ,temp.getY()+5 ,null);
					
				}
			}
		}
		if(pick!=null)
		{	//disegno per ultimo il pezzo che ho preso cos risulter in primo piano
			g.drawImage(pick.getImage(), pick.getX() ,pick.getY() ,null);
		}
	}
	/**
		metodo sovrascritto per disegnare l'interfaccia
	*/
	public void paint(Graphics g){
		Graphics screengc=null;
		screengc=g;
		g=buffer.getGraphics();
		g.drawImage(scacchiera,0,0,null);
		disegnaPezzi(g);
		screengc.drawImage(buffer,offset,offset,null);
		
	}
	
	
	//controlla se la casella  occupata
	/**
		Controlla se la casella  occupata da un pezzo
		@param c  la casella da controllare
		@return restituisce true se la casella  occupata altrimenti false
		
	*/
	public boolean casellaOccupata(Caselle c)
	{
		for(int i=0;i<numPezzi;i++)
		{
			if(posPezzi[i].indexOf(c.toString())!=-1)
				return true;
		
		}
		return false;
	}
	// torna la stringa contenente il nome del pezzo
	/**
		Serve per ottenere il nome del pezzo dentro casa
		@param casa stringa della casa dove si trova il pezzo
		@return restituisce il nome del pezzo
	*/
	public String getPezzo(String casa)
	{
		for(int i=0;i<numPezzi;i++)
		{
			if(posPezzi[i].indexOf(casa)!=-1)
			{
				return posPezzi[i].substring(0,1);
			}
		}
		return "";
	}
	/**
		Controlla se il mouse ha cliccato su di un pezzo
		@param x la coordinata x del mouse
		@param y la coordinata y del mouse
		@return restituisce il pezzo cliccato, altrimenti null
	*/
	public Pezzo ChessHit(int x, int y)
	{
		for (int i=0;i<8;i++)
			for(int j=0;j<8;j++)
			{
				if(x>=lista[j][i].x && x<(lista[j][i].x+lista[j][i].xOffset) && y>=lista[j][i].y && y<(lista[j][i].y+lista[j][i].yOffset))
				{
					return lista[j][i].getPezzo();
				}
			}
		return null;
	}
	/**
		Controlla se il mouse ha cliccato su di una casella della scacchiera
		@param x la coordinata x del mouse
		@param y la coordinata y del mouse
		@return restituisce la casella cliccata, altrimenti null
	*/
	public Caselle CasellaHit(int x, int y)
	{
		for (int i=0;i<8;i++)
			for(int j=0;j<8;j++)
			{
				if(x>=lista[j][i].x && x<(lista[j][i].x+lista[j][i].xOffset) && y>=lista[j][i].y && y<(lista[j][i].y+lista[j][i].yOffset))
				{
					return lista[j][i];
				}
			}
		return null;
	
	}
	/**
		Seleziona, se esiste, il pezzo in posizione x,y, salvando la sua posizione iniziale, dx e dy
		@param x la coordinata x del mouse
		@param y la coordinata y del mouse
		@see #partenza
		@see #dx
		@see #dy
	*/
	public void selectChess(int x, int y)
	{
		pick=ChessHit(x,y);
		if(pick!=null){
			partenza=pick.pos.toString();
			dx=pick.getX()-x+5; //tengo conto del fatto che i pezzi sono disegnati a +5 rispetto le caselle
			dy=pick.getY()-y+5;
			pickName=pick.getName();
		
		}
		else
			partenza="";
		
	}
	/**
		Aggiorna la posizione sullo schermo del pezzo che si sta trascinando con il mouse
		@param x la coordinata x del mouse
		@param y la coordinata y del mouse
	*/
	public void dragChess(int x, int y)
	{
		if(pick!=null){
			pick.setX(x+dx);
			pick.setY(y+dy);
			paint(getGraphics());
			
		}
	
	}
	/**
		Lascia il pezzo nella posizione x,y, aggiorna la casellaArrivo ed esegue la mossa
		@param x la coordinata x del mouse
		@param y la coordinata y del mouse
		@see #casellaArrivo
		@see #eseguiMossa()
	*/
	public void dropChess(int x, int y)
	{
		casellaArrivo=CasellaHit(x,y);
		if(pick!=null)
		{	
			pick.reset();
			ListaPosPezziTesto l=partita.getPosizionePezzi();
			aggiornaScacchiera(l);
			
		}
		if(casellaArrivo!=null){
			arrivo=casellaArrivo.toString();
			eseguiMossa();
				
			
		}else{
			arrivo="";
			
		}
		pick=null; //lascio il pezzo
		paint(getGraphics());//al posto di repaint() cos si riduce lo sfarfallio
	}
	//esegue la mossa
	/**
		Esegue la mossa combinando la posizione iniziale con quella finale
		@see #partenza
		@see #arrivo
	*/
	public void eseguiMossa(){
		ListaPosPezziTesto l;
		MossaTesto mossa=null;
		try{
			mossa=new MossaTesto(partenza+arrivo);
			try{
				l=partita.eseguiMossa(mossa);
				aggiornaScacchiera(l);
				mosse.setText(partita.listaMosse().toString());
				info.setText("Eseguita mossa '"+mossa.toString()+"'");
				if(partita.getMosseValide().toString().equals(""))
				{	
					if(partita.scaccoAlRe())
						info.setText("Scacco matto!! Cominciare una nuova partita o tornare indietro con le mosse");
					else
						info.setText("Partita patta. Cominciare una nuova partita o tornare indietro con le mosse");
				}
			}catch(MossaException me)
			{
				if(me.toString().indexOf("promozione")!=-1)
				{
					// la mossa  una promozione
					PromozioneDialog d=new PromozioneDialog(this,this,"Scegli la promozione");
					d.setVisible(true);
					try{
						mossa=new MossaTesto(mossa.toString()+promozione);
						try{
						l=partita.eseguiMossa(mossa);
						aggiornaScacchiera(l);
						mosse.setText(partita.listaMosse().toString());
						info.setText("Eseguita mossa '"+mossa.toString()+"'");
						if(partita.getMosseValide().toString().equals(""))
						{	
							if(partita.scaccoAlRe())
								info.setText("Scacco matto!! Cominciare una nuova partita o tornare indietro con le mosse");
							else
								info.setText("Partita patta. Cominciare una nuova partita o tornare indietro con le mosse");
						}
					}catch(MossaException e)
					{
						info.setText(e.toString().substring(me.toString().indexOf(":")+2));
					}
					}catch(NotazioneException nne)
					{
					
					}
				}else{
					info.setText(me.toString().substring(me.toString().indexOf(":")+2));
				}
			}
		}catch(NotazioneException ne)
		{
		
		}
		
		
	}
	/**
		Classe per rappresentare le caselle della scacchiera	
	*/
	class Caselle{
		/**
			Coordinata che rappresenta la x dell'angolo in alto a sinistra della casella
		*/
		int x;
		/**
			Coordinata che rappresenta la y dell'angolo in alto a sinistra della casella
		*/
		int y;
		/**
			Spiazzamento rispetto alla x prima di arrivare alla casella successiva
		*/
		int xOffset;
		/**
			Spiazzamento rispetto alla y prima di arrivare alla casella successiva
		*/
		int yOffset;
		/**
			Pezzo che si trova su questa casella (se ne esiste uno)
		*/
		Pezzo chess;
		/**
			Nome della casella
			es: "a1"
		*/
		String name;
		/**
			Costruisce una casella
			@param xOf rappresenta l'offset rispetto la x
			@param yOf rappresenta l'offset rispetto la y
			@param nx coordinata che rappresenta la x dell'angolo in alto a sinistra della casella
			@param ny coordinata che rappresenta la y dell'angolo in alto a sinistra della casella
			@param c il nome della casella
			@see #xOffset
			@see #yOffset
			@see #x
			@see #y
			@see #name
		*/
		public Caselle(int xOf, int yOf, int nx, int ny, String c)
		{
			xOffset=xOf;
			yOffset=yOf;
			x=nx;
			y=ny;
			name=c;
		}
		/**
			Metodo sovrascritto, serve per rappresentare con una stringa la casella
			@return il nome della casella
			@see #name
		*/
		public String toString(){
			return name;
		}
		/**
			Metodo per ottenere la coordinata x della casella
			@return la coordinata x della casella
			@see #x
		*/
		public int getX()
		{
			return x;
		}
		/**
			Metodo per impostare la coordinata x della casella
			@see #x	
		*/
		public void setX(int x)
		{
			this.x=x;
		}
		/**
			Metodo per ottenere la coordinata y della casella
			@return la coordinata y della casella
			@see #y
		*/
		public int getY()
		{
			return y;
		}
		/**
			Metodo per impostare la coordinata y della casella
			@see #y	
		*/
		public void setY(int y)
		{
			this.y=y;
		}
		/**
			Metodo per ottenere il pezzo che si trova sulla casella
			@return il pezzo (se ne esiste uno) che si trova sulla casella	
		*/
		public Pezzo getPezzo()
		{
			return chess;
		}
		/**
			Metodo per salvare un pezzo sulla casella
			@param nomePezzo il nome del pezzo da salvare
			@see GiocaAScacchi.Pezzo
		*/
		public void addPezzo(String nomePezzo)
		{
			chess=new Pezzo(nomePezzo, this);
		
		}
	}
	/** 
		Classe per rappresentare i pezzi degli scacchi
	*/
	class Pezzo{
		/**
			Salva la casella dove si trova il pezzo
			@see GiocaAScacchi.Caselle
		*/
		private Caselle pos;
		/**
			Nome del pezzo
		*/
		private String name;
		/**
			Immagine associata al pezzo
		*/
		private Image pezzo;
		/**
			Coordinata x della posizione del pezzo
		*/
		private int x;
		/**
			Coordinata x della posizione del pezzo
		*/
		private int y;
		/**
			Coordinata x della posizione iniziale del pezzo
		*/
		private int ox;
		/**
			Coordinata y della posizione iniziale del pezzo
		*/
		private int oy;
		/**
			Costruisce un pezzo
			@param nomePezzo nome del pezzo da creare
			@param casella casella su cui si trova il pezzo
		*/
		public Pezzo(String nomePezzo, Caselle casella)
		{
			name=nomePezzo;
			String nomeFile=nomePezzo.toLowerCase();
			if(nomeFile.equals(nomePezzo))
				nomeFile+="n";
			nomeFile+=".gif";
			pos=casella;
			x=casella.getX();
			y=casella.getY();
			ox=casella.getX();
			oy=casella.getY();
			try{
				pezzo=ImageIO.read(new File("images/"+nomeFile));
			}catch(IOException e){
				System.out.println("impossibile caricare l'immagine dei pezzi "+nomePezzo);
				System.exit(1);
			}
		
		}
		/**
			Restituisce la coordinata x della posizione corrente del pezzo
			@return la coordinata x della posizione corrente del pezzo
			@see #x
		*/
		public int getX(){
			return x;
		}
		/**
			Restituisce la coordinata x della posizione iniziale del pezzo
			@return la coordinata x della posizione iniziale del pezzo
			@see #ox
		*/
		public int getOx(){
			return ox;
		}
		/**
			Restituisce la coordinata x della posizione corrente del pezzo
			@return la coordinata x della posizione corrente del pezzo
			@see #y
		*/
		public int getY(){
			return y;
		}
		/**
			Restituisce la coordinata y della posizione iniziale del pezzo
			@return la coordinata y della posizione iniziale del pezzo
			@see #oy
		*/
		public int getOy(){
			return oy;
		}
		/**
			Imposta la coordinata x della posizione corrente del pezzo
			@param x la coordinata x da impostare
			@see #x
		*/
		public void setX(int x)
		{
			this.x=x;
		}
		/**
			Imposta la coordinata y della posizione corrente del pezzo
			@param y la coordinata y da impostare
			@see #y
		*/
		public void setY(int y)
		{
			this.y=y;
		}
		/**
			Ripristina la posizione iniziale del pezzo
			@see #ox
			@see #oy
		*/
		public void reset()
		{
			x=ox;
			y=oy;
		}
		/**
			Ottiene la posizione del pezzo
			@return la casella sulla quale si trova il pezzo
		*/
		public Caselle getPos(){
			return pos;
		}
		/**
			Ottiene l'immagine associata al pezzo
			@return l'immagine associata al pezzo
			@see #pezzo
		*/	
		public Image getImage(){
			return pezzo;
		
		}
		/**
			Torna il nome del pezzo
			@return il nome del pezzo
			@see #name
		*/
		public String getName(){
			return name;
		}
	}
} 
/**
	Classe usata dall'interfaccia grafica per gestire gli eventi generati dai pulsanti del mouse
*/
class MyMouseAdapter extends MouseAdapter {
	/**
		Salva l'interfaccia alla quale  associato per poter invocare i suoi metodi
	*/
	GiocaAScacchi game;
	/**
		Costruisce il gestore
		@param game la classe GiocaAScacchi che ha chiamato il costruttore
		
	*/
	public MyMouseAdapter(GiocaAScacchi game)
	{
		this.game=game;
	}
	/**
		Metodo sovrascritto per gestire la pressione del tasto del mouse: chiama il metodo selectChess(int x, int y) della classe GiocaAScacchi
		con la x e la y della posizione corrente del mouse(meno l'offset)
		@param me il MouseEvent generato
		@see GiocaAScacchi#selectChess(int x, int y)
		@see GiocaAScacchi#offset
	*/
	public void mousePressed(MouseEvent me){
		game.selectChess(me.getX()-game.offset,me.getY()-game.offset);
	}
	/**
		Metodo sovrascritto per gestire il rilascio del tasto del mouse: chiama il metodo dropChess(int x, int y) della classe GiocaAScacchi
		con la x e la y della posizione corrente del mouse(meno l'offset)
		@param me il MouseEvent generato
		@see GiocaAScacchi#dropChess(int x, int y)
		@see GiocaAScacchi#offset
	*/
	public void mouseReleased(MouseEvent me){
		game.dropChess(me.getX()-game.offset,me.getY()-game.offset);
	}
	
}
/**
	Classe usata dall'interfaccia grafica per gestire gli eventi generati dallo spostamento del mouse 
*/
class MyMouseMotionAdapter extends MouseMotionAdapter{
	/**
		Salva l'interfaccia alla quale  associato per poter invocare i suoi metodi
	*/
	GiocaAScacchi game;
	/**
		Costruisce il gestore
		@param game la classe GiocaAScacchi che ha chiamato il costruttore
		
	*/
	public MyMouseMotionAdapter(GiocaAScacchi game)
	{
		this.game=game;
	}
	/**
		Metodo sovrascritto per gestire il movimento del mouse con il tasto premuto: chiama il metodo dragChess(int x, int y) della classe GiocaAScacchi
		con la x e la y della posizione corrente del mouse(meno l'offset)
		@param me il MouseEvent generato
		@see GiocaAScacchi#dragChess(int x, int y)
		@see GiocaAScacchi#offset
	*/
	public synchronized void mouseDragged(MouseEvent me){
			game.dragChess(me.getX()-game.offset,me.getY()-game.offset);
	}
}
/**
	Classe usata dall'interfaccia grafica per gestire gli eventi collegati alla finestra principale
*/
class MyWindowAdapter extends WindowAdapter{
	/**
		Metodo sovrascritto per gestire la chiusura della finestra se si clicca sulla X in alto a destra
	*/
	public void windowClosing(WindowEvent we){
		System.exit(0);
	}

}
/**
	Finestra di dialogo per iniziare una nuova partita: permette di scegliere se iniziare dalla posizione standard, oppure se immettere la lista della posizione
	dei pezzi sulla scacchiera.
	Usata dall'interfaccia grafica
*/
class NewGameDialog extends Dialog implements ActionListener, ItemListener{
		/**
			Area di testo per immettere la lista della posizione dei pezzi sulla scacchiera
		*/
		TextArea listaPezzi;
		/**
			Gruppo di scelta per sapere se si vuole una partita standard o no
		*/
		CheckboxGroup choice;
		/**
			Gruppo di scelta per sapere chi ha il tratto se si vuole una partita non standard
			@see GiocaAScacchi#tratto
		*/
		CheckboxGroup tratto;
		/**
			Salva l'interfaccia dalla quale  chiamata per poter invocare i suoi metodi
		*/
		GiocaAScacchi chiamante;
		/**
			Mossa al bianco se selezionato
		*/
		Checkbox bianco;
		/**
			Mossa al nero se selezionato
		*/
		Checkbox nero;
	/**
		Costruisce una finestra di dialogo modale
		@param parent il frame che ha chiamato il costruttore
		@param chiamante la classe GiocaAScacchi che ha chiamato il costruttore
		@param titolo il titolo della finestra
	*/
	NewGameDialog(Frame parent,GiocaAScacchi chiamante, String titolo){
		super(parent,titolo, true); // dialogo modale
		this.chiamante=chiamante;
		setLayout(null);
		setBounds(300,300,400,380);
		Button ok=new Button("ok");
		ok.setBounds(180,290,40,30);
		add(ok);
		ok.addActionListener(this);
		choice=new CheckboxGroup();
		tratto=new CheckboxGroup();
		Checkbox standard=new Checkbox("Standard",choice,true);
		Checkbox lista=new Checkbox("Specificare Posizione Pezzi",choice,false);
		standard.setBounds(40,40,100,30);
		lista.setBounds(40,80,200,30);
		standard.addItemListener(this);
		lista.addItemListener(this);
		add(standard);
		add(lista);
		bianco=new Checkbox("mossa al bianco",tratto,true);
		nero=new Checkbox("mossa al nero",tratto,false);
		bianco.setBounds(90,120,200,30);
		nero.setBounds(90,160,200,30);
		bianco.setEnabled(false);
		nero.setEnabled(false);
		bianco.addItemListener(this);
		nero.addItemListener(this);
		add(bianco);
		add(nero);
		listaPezzi=new TextArea("",4,40,1);
		listaPezzi.setBounds(40,200,320,80);
		listaPezzi.setEditable(false);
		add(listaPezzi);
	}
	/**
		Metodo per gestire la pressione del pulsante "ok" all'interno della finestra:
		se  stata selezionata una partita non standard chiamer i metodi della classe GiocaAScacchi opportuni per settare la posizione dei pezzi 
		specificata e il tratto
		@param ae l'evento generato
		@see #listaPezzi
		@see #tratto
		@see GiocaAScacchi#setListaPezzi(java.lang.String)
		@see GiocaAScacchi#setTratto(int)
	*/
	public void actionPerformed(ActionEvent ae){
		String str=ae.getActionCommand();
		if(str.equals("ok")){
			if(choice.getSelectedCheckbox().getLabel().equals("Specificare Posizione Pezzi"))
			{
				chiamante.setListaPezzi(" "+listaPezzi.getText());
				chiamante.setTratto(tratto.getSelectedCheckbox().getLabel().equals("mossa al bianco")?1:-1);
			}
			dispose();
		}
	}
	/**
		Metodo per gestire la scelta del tipo di partita da iniziare
		@param ie l'evento generato
	*/
	public void itemStateChanged(ItemEvent ie){
		if(choice.getSelectedCheckbox().getLabel().equals("Specificare Posizione Pezzi"))
		{	
			listaPezzi.setEditable(true);
			bianco.setEnabled(true);
			nero.setEnabled(true);
		}else{
			listaPezzi.setEditable(false);
			bianco.setEnabled(false);
			nero.setEnabled(false);
		}
		repaint();
	}
	/**
		Disegna l'area dentro la finestra di dialogo
	*/
	public void paint(Graphics g){
	
	
	}
}

/**
	Finestra di dialogo per scegliere la promozione per il pedone.
	Usata dall'interfaccia grafica
*/
class PromozioneDialog extends Dialog implements ActionListener, ItemListener{
		/**
			Gruppo di scelta per sapere in quale pezzo si vuole promuovere il pedone
		*/
		CheckboxGroup choice;
		/**
			Salva l'interfaccia dalla quale  chiamata per poter invocare i suoi metodi
		*/
		GiocaAScacchi chiamante;
		
	/**
		Costruisce una finestra di dialogo modale
		@param parent il frame che ha chiamato il costruttore
		@param chiamante la classe GiocaAScacchi che ha chiamato il costruttore
		@param titolo il titolo della finestra
	*/
	PromozioneDialog(Frame parent,GiocaAScacchi chiamante, String titolo){
		super(parent,titolo, true); // dialogo modale
		this.chiamante=chiamante;
		setLayout(null);
		setBounds(300,300,200,230);
		Button ok=new Button("ok");
		ok.setBounds(80,190,40,30);
		add(ok);
		ok.addActionListener(this);
		choice=new CheckboxGroup();
		Checkbox donna=new Checkbox("Donna",choice,true);
		Checkbox cavallo=new Checkbox("Cavallo",choice,false);
		Checkbox torre=new Checkbox("Torre",choice,false);
		Checkbox alfiere=new Checkbox("Alfiere",choice,false);
		donna.setBounds(40,40,100,30);
		cavallo.setBounds(40,80,100,30);
		torre.setBounds(40,120,100,30);
		alfiere.setBounds(40,160,100,30);
		donna.addItemListener(this);
		cavallo.addItemListener(this);
		torre.addItemListener(this);
		alfiere.addItemListener(this);
		add(donna);
		add(cavallo);
		add(torre);
		add(alfiere);
	}
	/**
		Metodo per gestire la pressione del pulsante "ok" all'interno della finestra
		@param ae l'evento generato
	*/
	public void actionPerformed(ActionEvent ae){
		String str=ae.getActionCommand();
		if(str.equals("ok")){
			chiamante.setPromozione(choice.getSelectedCheckbox().getLabel().substring(0,1));
			dispose();
		}
	}
	/**
		Metodo per gestire la scelta del pezzo in cui si vuole promuovere il pedone
		@param ie l'evento generato
	*/
	public void itemStateChanged(ItemEvent ie){
	
		repaint();
	}
	/**
		Disegna l'area dentro la finestra di dialogo
	*/
	public void paint(Graphics g){
	
	
	}
}

